# target #
f=function(x){
  if(x<=3 & x>=-3) res=exp(-x^2/2) else res=0
  res
}

library ("msm")

# ordinary MCMC #
N=5000
sigma=2
x=rep(0,N+1)
x[1]=2
a=Sys.time()
for (i in 1:N){
  temp=rtnorm(1,x[i],sigma,lower=-3,upper=3)
  if(runif(1,0,1)<=f(temp)*dtnorm(x[i],temp,sigma,lower=-3,upper=3)/f(x[i])/dtnorm(temp,x[i],sigma,lower=-3,upper=3)){
    x[i+1]=temp
  } else x[i+1]=x[i]
}
fit=density(x,from=-3,to=3,n=100)
true=dtnorm(fit$x,0,1,lower=-3,upper=3)
tv=0.5*sum(abs(true-fit$y))*6/100
tv

# R-SMS-CBMC #
multi=function(x,s)
{
  length(which(x==s))
}

N=5000
K=2
sigma=2
S=matrix(0,N+1,K)
X=NULL
x[1]=2;S[1,]=x[1]
a=Sys.time()
for (i in 1:N){
  id=sample(1:K,1)
  tmp=S[i,];tmp[id]=rtnorm(1,S[i,id],sigma,lower=-3,upper=3);
  if(runif(1,0,1)<=sum(sapply(tmp,f))*multi(tmp[id],tmp)*dtnorm(S[i,id],tmp[id],sigma,lower=-3,upper=3)/sum(sapply(S[i,],f))/multi(S[i,id],S[i,])/dtnorm(tmp[id],S[i,id],sigma,lower=-3,upper=3)) {
    S[i+1,]=tmp;
    prop=sapply(S[i+1,],f);
    x.id=sample(1:K,1,prob=prop);
    x[i+1]=S[i+1,x.id];
  } else {S[i+1,]=S[i,];x[i+1]=x[i]}
}
fit=density(x,from=-3,to=3,n=100)
true=dtnorm(fit$x,0,1,lower=-3,upper=3)
tv=0.5*sum(abs(true-fit$y))*6/100
tv
